/*
 *   GRacer
 *
 *   Copyright (C) 1999 Takashi Matsuda <matsu@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include "gr_global.h"
#include "gr_debug.h"

GrDebugLevel __gr_debug_level = GR_DEBUG_WARNING;

GrDebugLevel
gr_get_debug_level	(void)
{
  return __gr_debug_level;
}

void
gr_set_debug_level (int level)
{
  if (level < 0)
    level = 0;

  if (level > GR_DEBUG_MESSAGE)
    level = GR_DEBUG_MESSAGE;

  __gr_debug_level = level;
}

#if defined (__GNUC__) && defined (GR_ENABLE_DEBUG)
GLenum __gl_error;
#endif
