/*
 *   GRacer
 *
 *   Copyright (C) 1999 Takashi Matsuda <matsu@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __GRACER_QUATERNION_H__
#define __GRACER_QUATERNION_H__

#include "gr_matrix.h"

typedef struct GrQuaternion
{
  float q0;
  GrVertex q;
} GrQuaternion;


#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif


void	gr_quaternion_add		(GrQuaternion *d,
					 GrQuaternion *a, GrQuaternion *b);
void	gr_quaternion_make_matrix	(GrQuaternion *quat, GrMatrix *m);
void	gr_quaternion_make_rotation_axis (GrQuaternion *quat, float *angle,
					  float *x, float *y, float *z);
void	gr_quaternion_normalize		(GrQuaternion *d, GrQuaternion *s);


#ifdef __cplusplus
}
#endif

#endif /* __GRACER_QUATERNION_H__ */
