/*
 *   GRacer
 *
 *   Copyright (C) 1999 Takashi Matsuda <matsu@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __GRACER_OPTION_H__
#define __GRACER_OPTION_H__


typedef enum {
  GR_OBJECT_NORMAL			= 1<<0,
  GR_OBJECT_COLOR			= 1<<1,
  GR_OBJECT_TEXTURE			= 1<<2,
  GR_OBJECT_MIPMAP			= 1<<3,
  GR_OBJECT_MATERIAL			= 1<<4,
  GR_OBJECT_FLAT			= 1<<5,
  GR_OBJECT_SMOOTH			= 1<<6,
  GR_OBJECT_MAG_NEAREST			= 1<<7,
  GR_OBJECT_MAG_LINEAR			= 1<<8,
  GR_OBJECT_MIN_NEAREST			= 1<<9,
  GR_OBJECT_MIN_LINEAR			= 1<<10,
  GR_OBJECT_MIP_NEAREST			= 1<<11,
  GR_OBJECT_MIP_LINEAR			= 1<<12,

  GR_OBJECT_DRAW			= 1<<13,

  GR_OBJECT_MAG_FILTER_MASK		= (GR_OBJECT_MAG_NEAREST|
					   GR_OBJECT_MAG_LINEAR),

  GR_OBJECT_MIN_FILTER_MASK		= (GR_OBJECT_MIN_NEAREST|
					   GR_OBJECT_MIN_LINEAR|
					   GR_OBJECT_MIP_NEAREST|
					   GR_OBJECT_MIP_LINEAR),

  GR_OBJECT_DEFAULT			= ~0,
  GR_OBJECT_ALL				= ~0,
} GrObjectDrawOption;


#endif /* __GRACER_OPTION_H__ */
