/*
 *   GRacer
 *
 *   Copyright (C) 1999 Takashi Matsuda <matsu@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __GRACER_GLUT_TCL_WIDGETS_H__
#define __GRACER_GLUT_TCL_WIDGETS_H__

#include "tcldefs.h"
#include "glutwidgets.h"

#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif

typedef struct	GlutTclRoot	GlutTclRoot;
typedef struct	GlutTclButton	GlutTclButton;
typedef struct	GlutTclEntry	GlutTclEntry;
typedef struct	GlutTclLabel	GlutTclLabel;

struct GlutTclRoot {
  GlutRoot core;

  Tcl_Command token;
  Tcl_Interp *interp;

  Tcl_Obj *display_script;
  Tcl_Interp *display_interp;

  Tcl_Obj *reshape_script;
  Tcl_Interp *reshape_interp;
};

struct GlutTclButton {
  GlutButton core;

  char *command_name;
  Tcl_Interp *interp;

  Tcl_Obj *invoke_script;
  Tcl_Interp *invoke_interp;
};

struct GlutTclEntry {
  GlutEntry core;

  char *command_name;
  Tcl_Interp *interp;

  Tcl_Interp *invoke_interp;
  Tcl_Obj *invoke_script;

  Tcl_Interp *changed_interp;
  Tcl_Obj *changed_script;
};

struct GlutTclLabel {
  GlutLabel core;

  char *command_name;
  Tcl_Interp *interp;
};

int	GlutTclWidget_Init		(Tcl_Interp *interp);

int	Tcl_GlutWidgetInsertHash	(Tcl_Interp *interp,
					 GlutObject obj,
					 char *key);

int	Tcl_GlutWidgetDeleteHash	(Tcl_Interp *interp,
					 char *key);

GlutObject Tcl_GetGlutObject		(Tcl_Interp *interp,
					 Tcl_Obj *CONST obj);

int	Tcl_GlutRootConfigure		(Tcl_Interp *interp,
					 GlutObject obj,
					 int objc,
					 Tcl_Obj *CONST objv[]);

int	Tcl_GlutWidgetConfigure		(Tcl_Interp *interp,
					 GlutObject obj,
					 int objc,
					 Tcl_Obj *CONST objv[]);

int	Tcl_GlutButtonConfigure		(Tcl_Interp *interp,
					 GlutObject obj,
					 int objc,
					 Tcl_Obj *CONST objv[]);

int	Tcl_GlutLabelConfigure		(Tcl_Interp *interp,
					 GlutObject obj,
					 int objc,
					 Tcl_Obj *CONST objv[]);

int	Tcl_GlutEntryConfigure		(Tcl_Interp *interp,
					 GlutObject obj,
					 int objc,
					 Tcl_Obj *CONST objv[]);


#ifdef __cplusplus
}
#endif

#endif /* __GRACER_GLUT_TCL_WIDGETS_H__ */
