/*
 *   GRacer
 *
 *   Copyright (C) 1999 Takashi Matsuda <matsu@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef __GRACER_LAP_H__
#define __GRACER_LAP_H__

#include <sys/time.h>
#include <common/gr_vertex.h>

typedef enum {
  GR_LAP_REGION_A,
  GR_LAP_REGION_B,
  GR_LAP_REGION_C,
} GrLapRegion;


double		gr_get_current_time	(void);

void		gr_time_add		(struct timeval *dst,
    					 struct timeval *src);

void		gr_time_sub		(struct timeval *dst,
    					 struct timeval *src);

void		gr_time_average		(struct timeval *dst,
    					 struct timeval *src,
					 double f);

void		gr_time_lt		(struct timeval *t1,
    					 struct timeval *t2);

GrLapRegion	gr_lap_which_region	(GrVertex *region, GrVertex *point);

#endif /* __GRACER_LAP_H__ */
